bomb_shape = {0, -4, 4, 0, 0, 4, -4, 0, 0, -4}

function update_bombs()
    for i = #bombs, 1, -1 do
        b = bombs[i]
        b.vy = b.vy + 50 * love.timer.getDelta()
        b.y = b.y + b.vy * love.timer.getDelta()
        b.x = b.x + b.vx * love.timer.getDelta()
        b.r = b.r + love.timer.getDelta()

        if b.y > ground_height(b.x) then
            sound_explosion_bomb:stop()
            sound_explosion_bomb:play()
            table.remove(bombs, i)
            spawn_debris(b.x, b.y, {255,128,0})
            for t = #tanks, 1, -1 do
                if math.abs(tanks[t].x - b.x) < 15 then
                    tanks[t].health = tanks[t].health - 5
                end
            end
        end
    end
end

function draw_bombs()
    for i,b  in ipairs(bombs) do
        love.graphics.push()
        love.graphics.translate(b.x, b.y)
        love.graphics.rotate(b.r)
        love.graphics.setColor(255,128,0,255)
        love.graphics.line(unpack(bomb_shape))
        love.graphics.pop()
    end
end

function drop_bomb()
    table.insert(bombs, 
        {x = player.x, 
         y = player.y, 
         vx = player.vx - sig(player.vx) * 10, 
         vy = player.vy + 50, 
         r = 0
    })
    debug_log("Bombs: " .. #bombs)
end

function init_bombs()
    bombs = {}
end
