bullet_shape = {0,-7,0,3}

function update_bullets()
    for bi = #bullets,1,-1 do
        if bullets[bi].spawn_time < love.timer.getTime() - 5 then
            table.remove(bullets, bi)
        else
            bullets[bi].old_x = bullets[bi].x
            bullets[bi].old_y = bullets[bi].y
            bullets[bi].x = bullets[bi].x + bullets[bi].vx * love.timer.getDelta() 
            bullets[bi].y = bullets[bi].y + bullets[bi].vy * love.timer.getDelta() 
            if ground_height(bullets[bi].x) < bullets[bi].y then
                table.remove(bullets, bi)
            end
        end
    end
end

function draw_bullets()
    love.graphics.setColor(0,0,255,255)
    for i,b in ipairs(bullets) do
        love.graphics.push()
        love.graphics.translate(b.x, b.y)
        love.graphics.rotate(b.r)
        love.graphics.line(unpack(bullet_shape))
        love.graphics.pop()
    end
end

function init_bullets()
    bullets = {}
end
