debris_shapes = {
    { -1, -1, 3, 2, 0, -3 },
    { -1, 2, 0, 7, 5, 4, 3, -1, -3, -1 },
    { -2, 3, 1, 3, 4, 3, 5, -3, 3, 1 },
    { -5, 1, 2, -3, 7, -1, 4, 2, 3, 1 },
}

function init_debris()
    debris = {}
end

function update_debris()
    for i = #debris, 1, -1 do
        d = debris[i]
        d.vy = d.vy + 50 * love.timer.getDelta()
        d.y = d.y + d.vy * love.timer.getDelta()
        d.x = d.x + d.vx * love.timer.getDelta()
        d.r = d.r + d.vr * love.timer.getDelta()
        d.a = math.max(d.a - 50 * love.timer.getDelta(), 0)
        if d.y > ground_height(d.x) then
            table.remove(debris, i)
        end
    end
end

function draw_debris()
    for i,d in pairs(debris) do
        love.graphics.push()
        love.graphics.translate(d.x, d.y)
        love.graphics.rotate(d.r)
        love.graphics.scale(d.size, d.size)
        love.graphics.setColor(d.color[1], d.color[2], d.color[3], d.a)
        love.graphics.polygon('line', debris_shapes[d.shape])
        love.graphics.pop()
    end

end

function spawn_debris(x,y, color, amount, size)
    if not amount then
        amount = 10
    end

    for i = 1, amount do
        table.insert(debris, {
            x = x,
            y = y - 1,
            vx = love.math.random() * 100 - 50,
            vy = love.math.random() * 100 - 50,
            shape = math.floor(love.math.random() * #debris_shapes) + 1,
            r = 0,
            vr = love.math.random() *  10 - 5,
            a = 255,
            color = color,
            size = size
        })
    end
end
