function init_fighters()
    fighters = { }

    last_fighter_spawn = 0
end

function draw_fighters()
    for i,pi in pairs(fighters) do
        love.graphics.push()
        love.graphics.translate(pi.x, pi.y)
        love.graphics.rotate(pi.r)
        love.graphics.setColor(255,0,0,255)
        love.graphics.line(-3,6,0,12,3,6)
        love.graphics.setColor(255,255,0,255)
        love.graphics.polygon('line', player_shape)
        love.graphics.pop()
    end
end

function update_fighters()
    if last_fighter_spawn < love.timer.getTime() - 10 then
        if #fighters < 3 then
            sound_new_fighter:stop()
            sound_new_fighter:play()
            table.insert(fighters,
                {x = player.x+128,
                 y = -200,
                 r = math.pi * 0.5,
                 last_bullet = 0,
                 vx = 0,
                 vy = 0,
                 health = 2
                 })
            last_fighter_spawn = love.timer.getTime()
        end
    end

    for i = #fighters, 1, -1 do

        local f = fighters[i]

        if f.health <= 0 then
            sound_explosion_fighter:stop()
            sound_explosion_fighter:play()
            table.remove(fighters, i)
            spawn_debris(f.x, f.y, {255,255,0}, 5, 1)
            score = score + 50

        else

            f.vx = math.sin(f.r) * 130
            f.vy = -math.cos(f.r) * 130
            
            local nx = f.vy
            local ny = -f.vx

            local d = 0

            if f.y > ground_height(f.y) - 64 and f.vy > 0 then
                d = -sig(f.vx)
            elseif math.abs(player.x - f.x) > 30 then
                d = -sig(nx * (player.x - f.x) + ny * (player.y - f.y))
            end

            f.r = f.r + d * math.pi * love.timer.getDelta()

            while f.r > math.pi do
                f.r = f.r - 2 * math.pi
            end
            
            while f.r < -math.pi do
                f.r = f.r + 2 * math.pi
            end

            if player.health > 0 and math.abs(math.acos(d)) < 0.01 and love.timer.getTime() > f.last_bullet + 0.1 and math.abs(player.x - f.x) < 128 then
                local lr = f.r + math.random() * 0.2 - 0.1
                local ox,oy = rotate(0,-9, f.r)
                sound_fighter:stop()
                sound_fighter:play()
                table.insert(bullets, {x = ox + f.x, 
                                       y = oy + f.y, 
                                       r = lr, 
                                       vx = f.vx + 200 * math.sin(lr), 
                                       vy = f.vy - 200 * math.cos(lr),
                                       spawn_time = love.timer.getTime(),
                                       f = 1})

                f.last_bullet = love.timer.getTime()
            end

            f.x = f.x + f.vx * love.timer.getDelta()
            f.y = f.y + f.vy * love.timer.getDelta()
        end
    end
end
