player_shape = {0,-8, -7,8, 0,4, 7,8 }
keys = {thrust= 'up',
        left= 'left',
        right= 'right',
        fire= 'x',
        fire2='c'}

bomb_key_was_down = false

function hurt_player(amount)
    if player.health > 0 then
        player.health = math.max(player.health - amount, 0)
        spawn_debris(player.x, player.y, {0,255,0}, 3, 0.5)

        if player.health == 0 then
            sound_thrust:stop()
            sound_explosion_player:stop()
            sound_explosion_player:play()
            spawn_debris(player.x, player.y, {0,255,0}, 30, 1, true)
        end
    end
end

function update_player()
    if player.health < 0 then
        player.health = 0
    elseif player.health > 0 then
        if love.keyboard.isDown(keys.left) then
            player.r = player.r - love.timer.getDelta() * 5 
        elseif love.keyboard.isDown(keys.right) then
            player.r = player.r + love.timer.getDelta() * 5
        end

        if love.keyboard.isDown(keys.thrust) then
            if not sound_thrust:isPlaying() then
                sound_thrust:play()
            end
            player.vx = player.vx + math.sin(player.r) * love.timer.getDelta() * 200
            player.vy = player.vy - math.cos(player.r) * love.timer.getDelta() * 200
        else
            sound_thrust:stop()
        end

        if love.keyboard.isDown(keys.fire) then
            if love.timer.getTime() > player.last_bullet + 0.1 then
                sound_gun:stop()
                sound_gun:play()
                local lr = player.r + math.random() * 0.2 - 0.1
                local ox,oy = rotate(0,-9, player.r)
                table.insert(bullets, {x = ox + player.x, 
                                       y = oy + player.y, 
                                       r = lr, 
                                       vx = player.vx + 200 * math.sin(lr), 
                                       vy = player.vy - 200 * math.cos(lr),
                                       spawn_time = love.timer.getTime(),
                                       f = 0})
                player.vx = player.vx - 5 * math.sin(lr)
                player.vy = player.vy + 5 * math.cos(lr)

                player.last_bullet = love.timer.getTime()
            end
        end

        if love.keyboard.isDown(keys.fire2) and not bomb_key_was_down and bomb_ammo > 0 then
            drop_bomb()
            bomb_ammo = bomb_ammo - 1
        end

        bomb_key_was_down = love.keyboard.isDown(keys.fire2)

        player.vy = player.vy + love.timer.getDelta() * 25

        player.vx = math.max(math.min(200, player.vx), -200)
        player.vy = math.max(math.min(200, player.vy), -200)

        player.x = player.x + love.timer.getDelta() * player.vx
        player.y = player.y + love.timer.getDelta() * player.vy

        if check_ground_collision(player_shape) > 0 then
            hurt_player(1000)
        end
    end
end

function draw_player()
    love.graphics.push()
    love.graphics.translate(player.x, player.y)
    love.graphics.rotate(player.r)

    if player.health > 0 then
        if love.keyboard.isDown(keys.thrust) then
            love.graphics.setColor(255,0,0,255)
            love.graphics.line(-3,6,0,12,3,6)
        end
        love.graphics.setColor(0,255,0,255)
        love.graphics.polygon('line', unpack(player_shape))
    end

    love.graphics.pop()
end
