function cu(f)
    return f*f*f
end

function sq(f)
    return f*f
end

function lerp(a,b,f)
    return (1.0-f)*a+f*b
end

function sig(x)
    if math.abs(x) < 0.0001 then
        return 1.0
    end
    return x / math.abs(x)
end

function between(a, b, c)
    return a >= math.min(b,c) and a <= math.max(b,c)
end

function bool_str(b)
    if b then
        return "true"
    else
        return "false"
    end
end

function line_line_intersection(x1,y1,x2,y2,x3,y3,x4,y4)
    local den = (x1 - x2)*(y3-y4) - (y1-y2)*(x3-x4)
    
    if math.abs(den) < 0.00001 then
        return nil
    end

    local px = ((x1*y2 - y1*x2)*(x3-x4) - (x1-x2)*(x3*y4 - y3*x4))/den
    local py = ((x1*y2 - y1*x2)*(y3-y4) - (y1-y2)*(x3*y4 - y3*x4))/den

    if between(px, x1, x2) and
       between(px, x3, x4) and
       between(py, y1, y2) and
       between(py, y3, y4) then
        return px,py
    end

    return nil
end

function rotate(px, py, r)
    return math.cos(r) * px - math.sin(r) * py,
           math.sin(r) * px + math.cos(r) * py
end

function debug_log(txt)
    if #debug_messages > 10 then
        table.remove(debug_messages, 1)
    end
    table.insert(debug_messages, txt)
end

debug_messages = {}
function draw_debug_log()
    for i, li in ipairs(debug_messages) do
        love.graphics.print(li, 10, 16 * i)
    end
end
